stages:
- build
- test
- deploy

variables:
  DOCKER_RUN_OPTS: "${CI_PROJECT_DIR}/.build:/src/test_results" # Share build space
  GIT_SUBMODULE_STRATEGY: recursive

build:
  stage: build
  when: on_success
  only:
    - production
  image: docker:stable
  script:
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY
    - docker build -t $CI_REGISTRY_IMAGE:$CI_COMMIT_SHORT_SHA -t $CI_REGISTRY_IMAGE:production .
    - docker push $CI_REGISTRY_IMAGE:$CI_COMMIT_SHORT_SHA
    - docker push $CI_REGISTRY_IMAGE:production
  variables:
    GIT_SUBMODULE_STRATEGY: recursive

build-staging:
  stage: build
  when: on_success
  only:
    - staging
  image: docker:stable
  script:
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY
    - docker build -t $CI_REGISTRY_IMAGE:$CI_COMMIT_SHORT_SHA -t $CI_REGISTRY_IMAGE:staging .
    - docker push $CI_REGISTRY_IMAGE:$CI_COMMIT_SHORT_SHA
    - docker push $CI_REGISTRY_IMAGE:staging
  variables:
    GIT_SUBMODULE_STRATEGY: recursive

test:
  stage: test
  when: on_success
  only:
    - production
  image: docker:stable
  script:
    - export PYTHONPATH="$PYTHONPATH:."
    - export PYTHONPATH="$PYTHONPATH:/src/app"
    - docker run -v ${CI_PROJECT_DIR}/.build:/src/test_results --entrypoint="/src/testApp.sh" $CI_REGISTRY_IMAGE:$CI_COMMIT_SHORT_SHA
  artifacts:
    public: true
    when: always
    reports:
      junit: ${CI_PROJECT_DIR}/.build/test_report.xml
    paths:
      - ${CI_PROJECT_DIR}/.build/test_report.html

test_staging:
  stage: test
  when: on_success
  only:
    - staging
  image: docker:stable
  script:
    - export PYTHONPATH="$PYTHONPATH:."
    - export PYTHONPATH="$PYTHONPATH:/src/app"
    - docker run -v ${CI_PROJECT_DIR}/.build:/src/test_results --entrypoint="/src/testApp.sh" $CI_REGISTRY_IMAGE:$CI_COMMIT_SHORT_SHA
  artifacts:
    public: true
    when: always
    reports:
      junit: ${CI_PROJECT_DIR}/.build/test_report.xml
    paths:
      - ${CI_PROJECT_DIR}/.build/test_report.html


deploy_staging:
  stage: deploy
  when: on_success
  only:
    - staging
  image: registry.gitlab.com/crowdsoft-foundation/various/pytestkube:latest
  script:
    - find ./. -type f \( -name '*_staging.yaml' \) -print0 | xargs -0 sed -i "s#\[image\]#$CI_REGISTRY_IMAGE:$CI_COMMIT_SHORT_SHA#g"
    - kubectl apply -f ./qrcodelinker_staging.yaml --kubeconfig="$KUBECONFIG_STAGING"

deploy_live:
  stage: deploy
  when: on_success
  only:
    - production
  image: registry.gitlab.com/crowdsoft-foundation/various/pytestkube:latest

  script:
    - find ./. -type f \( -name '*.yaml' \) -print0 | xargs -0 sed -i "s#\[image\]#$CI_REGISTRY_IMAGE:$CI_COMMIT_SHORT_SHA#g"
    - kubectl apply -f ./qrcodelinker.yaml --kubeconfig="$KUBECONFIG_LIVE"